Index: trunk/SophyaLib/NTools/fftpackc.h
===================================================================
--- trunk/SophyaLib/NTools/fftpackc.h	(revision 459)
+++ trunk/SophyaLib/NTools/fftpackc.h	(revision 710)
@@ -4,4 +4,7 @@
 #include "machdefs.h"
 /* #include "f2c.h" -- Remplace par ce qui suit */
+#ifdef __cplusplus
+extern "C" {
+#endif
 
 typedef int integer;
@@ -9,8 +12,8 @@
 typedef char *address;
 typedef short int shortint;
-typedef float real;
-typedef double doublereal;
-typedef struct { float r, i; } complex;
-typedef struct { double r, i; } doublecomplex;
+  // typedef float real;
+  // typedef double doublereal;
+  //typedef struct { float r, i; } complex;
+  //typedef struct { double r, i; } doublecomplex;
 
 /* typedef int_4 logical;
@@ -21,53 +24,53 @@
 /* ---------------------- */
 
-extern int cfftb_(integer *n, real *c__, real *wsave);
-extern int cfftb1_(integer *n, real *c__, real *ch, real *wa, integer *ifac);
-extern int cfftf_(integer *n, real *c__, real *wsave);
-extern int cfftf1_(integer *n, real *c__, real *ch, real *wa, integer *ifac);
-extern int cffti_(integer *n, real *wsave);
-extern int cffti1_(integer *n, real *wa, integer *ifac);
-extern int cosqb_(integer *n, real *x, real *wsave);
-extern int cosqb1_(integer *n, real *x, real *w, real *xh);
-extern int cosqf_(integer *n, real *x, real *wsave);
-extern int cosqf1_(integer *n, real *x, real *w, real *xh);
-extern int cosqi_(integer *n, real *wsave);
-extern int cost_(integer *n, real *x, real *wsave);
-extern int costi_(integer *n, real *wsave);
-extern int ezfft1_(integer *n, real *wa, integer *ifac);
-extern int ezfftb_(integer *n, real *r__, real *azero, real *a, real *b, real *wsave);
-extern int ezfftf_(integer *n, real *r__, real *azero, real *a, real *b, real *wsave);
-extern int ezffti_(integer *n, real *wsave);
-extern int passb_(integer *nac, integer *ido, integer *ip, integer *l1, integer *idl1, real *cc, real *c1, real *c2, real *ch, real *ch2, real *wa);
-extern int passb2_(integer *ido, integer *l1, real *cc, real *ch, real *wa1);
-extern int passb3_(integer *ido, integer *l1, real *cc, real *ch, real *wa1, real *wa2);
-extern int passb4_(integer *ido, integer *l1, real *cc, real *ch, real *wa1, real *wa2, real *wa3);
-extern int passb5_(integer *ido, integer *l1, real *cc, real *ch, real *wa1, real *wa2, real *wa3, real *wa4);
-extern int passf_(integer *nac, integer *ido, integer *ip, integer *l1, integer *idl1, real *cc, real *c1, real *c2, real *ch, real *ch2, real *wa);
-extern int passf2_(integer *ido, integer *l1, real *cc, real *ch, real *wa1);
-extern int passf3_(integer *ido, integer *l1, real *cc, real *ch, real *wa1, real *wa2);
-extern int passf4_(integer *ido, integer *l1, real *cc, real *ch, real *wa1, real *wa2, real *wa3);
-extern int passf5_(integer *ido, integer *l1, real *cc, real *ch, real *wa1, real *wa2, real *wa3, real *wa4);
-extern int radb2_(integer *ido, integer *l1, real *cc, real *ch, real *wa1);
-extern int radb3_(integer *ido, integer *l1, real *cc, real *ch, real *wa1, real *wa2);
-extern int radb4_(integer *ido, integer *l1, real *cc, real *ch, real *wa1, real *wa2, real *wa3);
-extern int radb5_(integer *ido, integer *l1, real *cc, real *ch, real *wa1, real *wa2, real *wa3, real *wa4);
-extern int radbg_(integer *ido, integer *ip, integer *l1, integer *idl1, real *cc, real *c1, real *c2, real *ch, real *ch2, real *wa);
-extern int radf2_(integer *ido, integer *l1, real *cc, real *ch, real *wa1);
-extern int radf3_(integer *ido, integer *l1, real *cc, real *ch, real *wa1, real *wa2);
-extern int radf4_(integer *ido, integer *l1, real *cc, real *ch, real *wa1, real *wa2, real *wa3);
-extern int radf5_(integer *ido, integer *l1, real *cc, real *ch, real *wa1, real *wa2, real *wa3, real *wa4);
-extern int radfg_(integer *ido, integer *ip, integer *l1, integer *idl1, real *cc, real *c1, real *c2, real *ch, real *ch2, real *wa);
-extern int rfftb_(integer *n, real *r__, real *wsave);
-extern int rfftb1_(integer *n, real *c__, real *ch, real *wa, integer *ifac);
-extern int rfftf_(integer *n, real *r__, real *wsave);
-extern int rfftf1_(integer *n, real *c__, real *ch, real *wa, integer *ifac);
-extern int rffti_(integer *n, real *wsave);
-extern int rffti1_(integer *n, real *wa, integer *ifac);
-extern int sinqb_(integer *n, real *x, real *wsave);
-extern int sinqf_(integer *n, real *x, real *wsave);
-extern int sinqi_(integer *n, real *wsave);
-extern int sint_(integer *n, real *x, real *wsave);
-extern int sint1_(integer *n, real *war, real *was, real *xh, real *x, integer *ifac);
-extern int sinti_(integer *n, real *wsave);
+extern int cfftb_(integer *n, float *c__, float *wsave);
+extern int cfftb1_(integer *n, float *c__, float *ch, float *wa, integer *ifac);
+extern int cfftf_(integer *n, float *c__, float *wsave);
+extern int cfftf1_(integer *n, float *c__, float *ch, float *wa, integer *ifac);
+extern int cffti_(integer *n, float *wsave);
+extern int cffti1_(integer *n, float *wa, integer *ifac);
+extern int cosqb_(integer *n, float *x, float *wsave);
+extern int cosqb1_(integer *n, float *x, float *w, float *xh);
+extern int cosqf_(integer *n, float *x, float *wsave);
+extern int cosqf1_(integer *n, float *x, float *w, float *xh);
+extern int cosqi_(integer *n, float *wsave);
+extern int cost_(integer *n, float *x, float *wsave);
+extern int costi_(integer *n, float *wsave);
+extern int ezfft1_(integer *n, float *wa, integer *ifac);
+extern int ezfftb_(integer *n, float *r__, float *azero, float *a, float *b, float *wsave);
+extern int ezfftf_(integer *n, float *r__, float *azero, float *a, float *b, float *wsave);
+extern int ezffti_(integer *n, float *wsave);
+extern int passb_(integer *nac, integer *ido, integer *ip, integer *l1, integer *idl1, float *cc, float *c1, float *c2, float *ch, float *ch2, float *wa);
+extern int passb2_(integer *ido, integer *l1, float *cc, float *ch, float *wa1);
+extern int passb3_(integer *ido, integer *l1, float *cc, float *ch, float *wa1, float *wa2);
+extern int passb4_(integer *ido, integer *l1, float *cc, float *ch, float *wa1, float *wa2, float *wa3);
+extern int passb5_(integer *ido, integer *l1, float *cc, float *ch, float *wa1, float *wa2, float *wa3, float *wa4);
+extern int passf_(integer *nac, integer *ido, integer *ip, integer *l1, integer *idl1, float *cc, float *c1, float *c2, float *ch, float *ch2, float *wa);
+extern int passf2_(integer *ido, integer *l1, float *cc, float *ch, float *wa1);
+extern int passf3_(integer *ido, integer *l1, float *cc, float *ch, float *wa1, float *wa2);
+extern int passf4_(integer *ido, integer *l1, float *cc, float *ch, float *wa1, float *wa2, float *wa3);
+extern int passf5_(integer *ido, integer *l1, float *cc, float *ch, float *wa1, float *wa2, float *wa3, float *wa4);
+extern int radb2_(integer *ido, integer *l1, float *cc, float *ch, float *wa1);
+extern int radb3_(integer *ido, integer *l1, float *cc, float *ch, float *wa1, float *wa2);
+extern int radb4_(integer *ido, integer *l1, float *cc, float *ch, float *wa1, float *wa2, float *wa3);
+extern int radb5_(integer *ido, integer *l1, float *cc, float *ch, float *wa1, float *wa2, float *wa3, float *wa4);
+extern int radbg_(integer *ido, integer *ip, integer *l1, integer *idl1, float *cc, float *c1, float *c2, float *ch, float *ch2, float *wa);
+extern int radf2_(integer *ido, integer *l1, float *cc, float *ch, float *wa1);
+extern int radf3_(integer *ido, integer *l1, float *cc, float *ch, float *wa1, float *wa2);
+extern int radf4_(integer *ido, integer *l1, float *cc, float *ch, float *wa1, float *wa2, float *wa3);
+extern int radf5_(integer *ido, integer *l1, float *cc, float *ch, float *wa1, float *wa2, float *wa3, float *wa4);
+extern int radfg_(integer *ido, integer *ip, integer *l1, integer *idl1, float *cc, float *c1, float *c2, float *ch, float *ch2, float *wa);
+extern int rfftb_(integer *n, float *r__, float *wsave);
+extern int rfftb1_(integer *n, float *c__, float *ch, float *wa, integer *ifac);
+extern int rfftf_(integer *n, float *r__, float *wsave);
+extern int rfftf1_(integer *n, float *c__, float *ch, float *wa, integer *ifac);
+extern int rffti_(integer *n, float *wsave);
+extern int rffti1_(integer *n, float *wa, integer *ifac);
+extern int sinqb_(integer *n, float *x, float *wsave);
+extern int sinqf_(integer *n, float *x, float *wsave);
+extern int sinqi_(integer *n, float *wsave);
+extern int sint_(integer *n, float *x, float *wsave);
+extern int sint1_(integer *n, float *war, float *was, float *xh, float *x, integer *ifac);
+extern int sinti_(integer *n, float *wsave);
 
 /* ---------------------- */
@@ -124,4 +127,7 @@
 
 /* Rerunning f2c -P may change prototypes or declarations. */
+#ifdef __cplusplus
+}
+#endif
 
 #endif /*  FFTPACK_H_SEEN */