Index: trunk/SophyaLib/NTools/fftpackc.h
===================================================================
--- trunk/SophyaLib/NTools/fftpackc.h	(revision 710)
+++ trunk/SophyaLib/NTools/fftpackc.h	(revision 717)
@@ -24,105 +24,105 @@
 /* ---------------------- */
 
-extern int cfftb_(integer *n, float *c__, float *wsave);
-extern int cfftb1_(integer *n, float *c__, float *ch, float *wa, integer *ifac);
-extern int cfftf_(integer *n, float *c__, float *wsave);
-extern int cfftf1_(integer *n, float *c__, float *ch, float *wa, integer *ifac);
-extern int cffti_(integer *n, float *wsave);
-extern int cffti1_(integer *n, float *wa, integer *ifac);
-extern int cosqb_(integer *n, float *x, float *wsave);
-extern int cosqb1_(integer *n, float *x, float *w, float *xh);
-extern int cosqf_(integer *n, float *x, float *wsave);
-extern int cosqf1_(integer *n, float *x, float *w, float *xh);
-extern int cosqi_(integer *n, float *wsave);
-extern int cost_(integer *n, float *x, float *wsave);
-extern int costi_(integer *n, float *wsave);
-extern int ezfft1_(integer *n, float *wa, integer *ifac);
-extern int ezfftb_(integer *n, float *r__, float *azero, float *a, float *b, float *wsave);
-extern int ezfftf_(integer *n, float *r__, float *azero, float *a, float *b, float *wsave);
-extern int ezffti_(integer *n, float *wsave);
-extern int passb_(integer *nac, integer *ido, integer *ip, integer *l1, integer *idl1, float *cc, float *c1, float *c2, float *ch, float *ch2, float *wa);
-extern int passb2_(integer *ido, integer *l1, float *cc, float *ch, float *wa1);
-extern int passb3_(integer *ido, integer *l1, float *cc, float *ch, float *wa1, float *wa2);
-extern int passb4_(integer *ido, integer *l1, float *cc, float *ch, float *wa1, float *wa2, float *wa3);
-extern int passb5_(integer *ido, integer *l1, float *cc, float *ch, float *wa1, float *wa2, float *wa3, float *wa4);
-extern int passf_(integer *nac, integer *ido, integer *ip, integer *l1, integer *idl1, float *cc, float *c1, float *c2, float *ch, float *ch2, float *wa);
-extern int passf2_(integer *ido, integer *l1, float *cc, float *ch, float *wa1);
-extern int passf3_(integer *ido, integer *l1, float *cc, float *ch, float *wa1, float *wa2);
-extern int passf4_(integer *ido, integer *l1, float *cc, float *ch, float *wa1, float *wa2, float *wa3);
-extern int passf5_(integer *ido, integer *l1, float *cc, float *ch, float *wa1, float *wa2, float *wa3, float *wa4);
-extern int radb2_(integer *ido, integer *l1, float *cc, float *ch, float *wa1);
-extern int radb3_(integer *ido, integer *l1, float *cc, float *ch, float *wa1, float *wa2);
-extern int radb4_(integer *ido, integer *l1, float *cc, float *ch, float *wa1, float *wa2, float *wa3);
-extern int radb5_(integer *ido, integer *l1, float *cc, float *ch, float *wa1, float *wa2, float *wa3, float *wa4);
-extern int radbg_(integer *ido, integer *ip, integer *l1, integer *idl1, float *cc, float *c1, float *c2, float *ch, float *ch2, float *wa);
-extern int radf2_(integer *ido, integer *l1, float *cc, float *ch, float *wa1);
-extern int radf3_(integer *ido, integer *l1, float *cc, float *ch, float *wa1, float *wa2);
-extern int radf4_(integer *ido, integer *l1, float *cc, float *ch, float *wa1, float *wa2, float *wa3);
-extern int radf5_(integer *ido, integer *l1, float *cc, float *ch, float *wa1, float *wa2, float *wa3, float *wa4);
-extern int radfg_(integer *ido, integer *ip, integer *l1, integer *idl1, float *cc, float *c1, float *c2, float *ch, float *ch2, float *wa);
-extern int rfftb_(integer *n, float *r__, float *wsave);
-extern int rfftb1_(integer *n, float *c__, float *ch, float *wa, integer *ifac);
-extern int rfftf_(integer *n, float *r__, float *wsave);
-extern int rfftf1_(integer *n, float *c__, float *ch, float *wa, integer *ifac);
-extern int rffti_(integer *n, float *wsave);
-extern int rffti1_(integer *n, float *wa, integer *ifac);
-extern int sinqb_(integer *n, float *x, float *wsave);
-extern int sinqf_(integer *n, float *x, float *wsave);
-extern int sinqi_(integer *n, float *wsave);
-extern int sint_(integer *n, float *x, float *wsave);
-extern int sint1_(integer *n, float *war, float *was, float *xh, float *x, integer *ifac);
-extern int sinti_(integer *n, float *wsave);
+extern int cfftb_(integer *n, r_4 *c__, r_4 *wsave);
+extern int cfftb1_(integer *n, r_4 *c__, r_4 *ch, r_4 *wa, int_4 *ifac);
+extern int cfftf_(integer *n, r_4 *c__, r_4 *wsave);
+extern int cfftf1_(integer *n, r_4 *c__, r_4 *ch, r_4 *wa, int_4 *ifac);
+extern int cffti_(integer *n, r_4 *wsave);
+extern int cffti1_(integer *n, r_4 *wa, int_4 *ifac);
+extern int cosqb_(integer *n, r_4 *x, r_4 *wsave);
+extern int cosqb1_(integer *n, r_4 *x, r_4 *w, r_4 *xh);
+extern int cosqf_(integer *n, r_4 *x, r_4 *wsave);
+extern int cosqf1_(integer *n, r_4 *x, r_4 *w, r_4 *xh);
+extern int cosqi_(integer *n, r_4 *wsave);
+extern int cost_(integer *n, r_4 *x, r_4 *wsave);
+extern int costi_(integer *n, r_4 *wsave);
+extern int ezfft1_(integer *n, r_4 *wa, int_4 *ifac);
+extern int ezfftb_(integer *n, r_4 *r__, r_4 *azero, r_4 *a, r_4 *b, r_4 *wsave);
+extern int ezfftf_(integer *n, r_4 *r__, r_4 *azero, r_4 *a, r_4 *b, r_4 *wsave);
+extern int ezffti_(integer *n, r_4 *wsave);
+extern int passb_(integer *nac, integer *ido, integer *ip, integer *l1, integer *idl1, r_4 *cc, r_4 *c1, r_4 *c2, r_4 *ch, r_4 *ch2, r_4 *wa);
+extern int passb2_(integer *ido, integer *l1, r_4 *cc, r_4 *ch, r_4 *wa1);
+extern int passb3_(integer *ido, integer *l1, r_4 *cc, r_4 *ch, r_4 *wa1, r_4 *wa2);
+extern int passb4_(integer *ido, integer *l1, r_4 *cc, r_4 *ch, r_4 *wa1, r_4 *wa2, r_4 *wa3);
+extern int passb5_(integer *ido, integer *l1, r_4 *cc, r_4 *ch, r_4 *wa1, r_4 *wa2, r_4 *wa3, r_4 *wa4);
+extern int passf_(integer *nac, integer *ido, integer *ip, integer *l1, integer *idl1, r_4 *cc, r_4 *c1, r_4 *c2, r_4 *ch, r_4 *ch2, r_4 *wa);
+extern int passf2_(integer *ido, integer *l1, r_4 *cc, r_4 *ch, r_4 *wa1);
+extern int passf3_(integer *ido, integer *l1, r_4 *cc, r_4 *ch, r_4 *wa1, r_4 *wa2);
+extern int passf4_(integer *ido, integer *l1, r_4 *cc, r_4 *ch, r_4 *wa1, r_4 *wa2, r_4 *wa3);
+extern int passf5_(integer *ido, integer *l1, r_4 *cc, r_4 *ch, r_4 *wa1, r_4 *wa2, r_4 *wa3, r_4 *wa4);
+extern int radb2_(integer *ido, integer *l1, r_4 *cc, r_4 *ch, r_4 *wa1);
+extern int radb3_(integer *ido, integer *l1, r_4 *cc, r_4 *ch, r_4 *wa1, r_4 *wa2);
+extern int radb4_(integer *ido, integer *l1, r_4 *cc, r_4 *ch, r_4 *wa1, r_4 *wa2, r_4 *wa3);
+extern int radb5_(integer *ido, integer *l1, r_4 *cc, r_4 *ch, r_4 *wa1, r_4 *wa2, r_4 *wa3, r_4 *wa4);
+extern int radbg_(integer *ido, integer *ip, integer *l1, integer *idl1, r_4 *cc, r_4 *c1, r_4 *c2, r_4 *ch, r_4 *ch2, r_4 *wa);
+extern int radf2_(integer *ido, integer *l1, r_4 *cc, r_4 *ch, r_4 *wa1);
+extern int radf3_(integer *ido, integer *l1, r_4 *cc, r_4 *ch, r_4 *wa1, r_4 *wa2);
+extern int radf4_(integer *ido, integer *l1, r_4 *cc, r_4 *ch, r_4 *wa1, r_4 *wa2, r_4 *wa3);
+extern int radf5_(integer *ido, integer *l1, r_4 *cc, r_4 *ch, r_4 *wa1, r_4 *wa2, r_4 *wa3, r_4 *wa4);
+extern int radfg_(integer *ido, integer *ip, integer *l1, integer *idl1, r_4 *cc, r_4 *c1, r_4 *c2, r_4 *ch, r_4 *ch2, r_4 *wa);
+extern int rfftb_(integer *n, r_4 *r__, r_4 *wsave);
+extern int rfftb1_(integer *n, r_4 *c__, r_4 *ch, r_4 *wa, int_4 *ifac);
+extern int rfftf_(integer *n, r_4 *r__, r_4 *wsave);
+extern int rfftf1_(integer *n, r_4 *c__, r_4 *ch, r_4 *wa, int_4 *ifac);
+extern int rffti_(integer *n, r_4 *wsave);
+extern int rffti1_(integer *n, r_4 *wa, int_4 *ifac);
+extern int sinqb_(integer *n, r_4 *x, r_4 *wsave);
+extern int sinqf_(integer *n, r_4 *x, r_4 *wsave);
+extern int sinqi_(integer *n, r_4 *wsave);
+extern int sint_(integer *n, r_4 *x, r_4 *wsave);
+extern int sint1_(integer *n, r_4 *war, r_4 *was, r_4 *xh, r_4 *x, int_4 *ifac);
+extern int sinti_(integer *n, r_4 *wsave);
 
 /* ---------------------- */
 
-extern int cdfftb_(integer *n, double *c__, double *wsave);
-extern int cdfftb1_(integer *n, double *c__, double *ch, double *wa, integer *ifac);
-extern int cdfftf_(integer *n, double *c__, double *wsave);
-extern int cdfftf1_(integer *n, double *c__, double *ch, double *wa, integer *ifac);
-extern int cdffti_(integer *n, double *wsave);
-extern int cdffti1_(integer *n, double *wa, integer *ifac);
-extern int dcosqb_(integer *n, double *x, double *wsave);
-extern int dcosqb1_(integer *n, double *x, double *w, double *xh);
-extern int dcosqf_(integer *n, double *x, double *wsave);
-extern int dcosqf1_(integer *n, double *x, double *w, double *xh);
-extern int dcosqi_(integer *n, double *wsave);
-extern int dcost_(integer *n, double *x, double *wsave);
-extern int dcosti_(integer *n, double *wsave);
-extern int dezfft1_(integer *n, double *wa, integer *ifac);
-extern int dezfftb_(integer *n, double *r__, double *azero, double *a, double *b, double *wsave);
-extern int dezfftf_(integer *n, double *r__, double *azero, double *a, double *b, double *wsave);
-extern int dezffti_(integer *n, double *wsave);
-extern int dpassb_(integer *nac, integer *ido, integer *ip, integer *l1, integer *idl1, double *cc, double *c1, double *c2, double *ch, double *ch2, double *wa);
-extern int dpassb2_(integer *ido, integer *l1, double *cc, double *ch, double *wa1);
-extern int dpassb3_(integer *ido, integer *l1, double *cc, double *ch, double *wa1, double *wa2);
-extern int dpassb4_(integer *ido, integer *l1, double *cc, double *ch, double *wa1, double *wa2, double *wa3);
-extern int dpassb5_(integer *ido, integer *l1, double *cc, double *ch, double *wa1, double *wa2, double *wa3, double *wa4);
-extern int dpassf_(integer *nac, integer *ido, integer *ip, integer *l1, integer *idl1, double *cc, double *c1, double *c2, double *ch, double *ch2, double *wa);
-extern int dpassf2_(integer *ido, integer *l1, double *cc, double *ch, double *wa1);
-extern int dpassf3_(integer *ido, integer *l1, double *cc, double *ch, double *wa1, double *wa2);
-extern int dpassf4_(integer *ido, integer *l1, double *cc, double *ch, double *wa1, double *wa2, double *wa3);
-extern int dpassf5_(integer *ido, integer *l1, double *cc, double *ch, double *wa1, double *wa2, double *wa3, double *wa4);
-extern int dadb2_(integer *ido, integer *l1, double *cc, double *ch, double *wa1);
-extern int dadb3_(integer *ido, integer *l1, double *cc, double *ch, double *wa1, double *wa2);
-extern int dadb4_(integer *ido, integer *l1, double *cc, double *ch, double *wa1, double *wa2, double *wa3);
-extern int dadb5_(integer *ido, integer *l1, double *cc, double *ch, double *wa1, double *wa2, double *wa3, double *wa4);
-extern int dadbg_(integer *ido, integer *ip, integer *l1, integer *idl1, double *cc, double *c1, double *c2, double *ch, double *ch2, double *wa);
-extern int dadf2_(integer *ido, integer *l1, double *cc, double *ch, double *wa1);
-extern int dadf3_(integer *ido, integer *l1, double *cc, double *ch, double *wa1, double *wa2);
-extern int dadf4_(integer *ido, integer *l1, double *cc, double *ch, double *wa1, double *wa2, double *wa3);
-extern int dadf5_(integer *ido, integer *l1, double *cc, double *ch, double *wa1, double *wa2, double *wa3, double *wa4);
-extern int dadfg_(integer *ido, integer *ip, integer *l1, integer *idl1, double *cc, double *c1, double *c2, double *ch, double *ch2, double *wa);
-extern int dfftb_(integer *n, double *r__, double *wsave);
-extern int dfftb1_(integer *n, double *c__, double *ch, double *wa, integer *ifac);
-extern int dfftf_(integer *n, double *r__, double *wsave);
-extern int dfftf1_(integer *n, double *c__, double *ch, double *wa, integer *ifac);
-extern int dffti_(integer *n, double *wsave);
-extern int dffti1_(integer *n, double *wa, integer *ifac);
-extern int dsinqb_(integer *n, double *x, double *wsave);
-extern int dsinqf_(integer *n, double *x, double *wsave);
-extern int dsinqi_(integer *n, double *wsave);
-extern int dsint_(integer *n, double *x, double *wsave);
-extern int dsint1_(integer *n, double *war, double *was, double *xh, double *x, integer *ifac);
-extern int dsinti_(integer *n, double *wsave);
+extern int cdfftb_(integer *n, r_8 *c__, r_8 *wsave);
+extern int cdfftb1_(integer *n, r_8 *c__, r_8 *ch, r_8 *wa, int_8 *ifac);
+extern int cdfftf_(integer *n, r_8 *c__, r_8 *wsave);
+extern int cdfftf1_(integer *n, r_8 *c__, r_8 *ch, r_8 *wa, int_8 *ifac);
+extern int cdffti_(integer *n, r_8 *wsave);
+extern int cdffti1_(integer *n, r_8 *wa, int_8 *ifac);
+extern int dcosqb_(integer *n, r_8 *x, r_8 *wsave);
+extern int dcosqb1_(integer *n, r_8 *x, r_8 *w, r_8 *xh);
+extern int dcosqf_(integer *n, r_8 *x, r_8 *wsave);
+extern int dcosqf1_(integer *n, r_8 *x, r_8 *w, r_8 *xh);
+extern int dcosqi_(integer *n, r_8 *wsave);
+extern int dcost_(integer *n, r_8 *x, r_8 *wsave);
+extern int dcosti_(integer *n, r_8 *wsave);
+extern int dezfft1_(integer *n, r_8 *wa, int_8 *ifac);
+extern int dezfftb_(integer *n, r_8 *r__, r_8 *azero, r_8 *a, r_8 *b, r_8 *wsave);
+extern int dezfftf_(integer *n, r_8 *r__, r_8 *azero, r_8 *a, r_8 *b, r_8 *wsave);
+extern int dezffti_(integer *n, r_8 *wsave);
+extern int dpassb_(integer *nac, integer *ido, integer *ip, integer *l1, integer *idl1, r_8 *cc, r_8 *c1, r_8 *c2, r_8 *ch, r_8 *ch2, r_8 *wa);
+extern int dpassb2_(integer *ido, integer *l1, r_8 *cc, r_8 *ch, r_8 *wa1);
+extern int dpassb3_(integer *ido, integer *l1, r_8 *cc, r_8 *ch, r_8 *wa1, r_8 *wa2);
+extern int dpassb4_(integer *ido, integer *l1, r_8 *cc, r_8 *ch, r_8 *wa1, r_8 *wa2, r_8 *wa3);
+extern int dpassb5_(integer *ido, integer *l1, r_8 *cc, r_8 *ch, r_8 *wa1, r_8 *wa2, r_8 *wa3, r_8 *wa4);
+extern int dpassf_(integer *nac, integer *ido, integer *ip, integer *l1, integer *idl1, r_8 *cc, r_8 *c1, r_8 *c2, r_8 *ch, r_8 *ch2, r_8 *wa);
+extern int dpassf2_(integer *ido, integer *l1, r_8 *cc, r_8 *ch, r_8 *wa1);
+extern int dpassf3_(integer *ido, integer *l1, r_8 *cc, r_8 *ch, r_8 *wa1, r_8 *wa2);
+extern int dpassf4_(integer *ido, integer *l1, r_8 *cc, r_8 *ch, r_8 *wa1, r_8 *wa2, r_8 *wa3);
+extern int dpassf5_(integer *ido, integer *l1, r_8 *cc, r_8 *ch, r_8 *wa1, r_8 *wa2, r_8 *wa3, r_8 *wa4);
+extern int dadb2_(integer *ido, integer *l1, r_8 *cc, r_8 *ch, r_8 *wa1);
+extern int dadb3_(integer *ido, integer *l1, r_8 *cc, r_8 *ch, r_8 *wa1, r_8 *wa2);
+extern int dadb4_(integer *ido, integer *l1, r_8 *cc, r_8 *ch, r_8 *wa1, r_8 *wa2, r_8 *wa3);
+extern int dadb5_(integer *ido, integer *l1, r_8 *cc, r_8 *ch, r_8 *wa1, r_8 *wa2, r_8 *wa3, r_8 *wa4);
+extern int dadbg_(integer *ido, integer *ip, integer *l1, integer *idl1, r_8 *cc, r_8 *c1, r_8 *c2, r_8 *ch, r_8 *ch2, r_8 *wa);
+extern int dadf2_(integer *ido, integer *l1, r_8 *cc, r_8 *ch, r_8 *wa1);
+extern int dadf3_(integer *ido, integer *l1, r_8 *cc, r_8 *ch, r_8 *wa1, r_8 *wa2);
+extern int dadf4_(integer *ido, integer *l1, r_8 *cc, r_8 *ch, r_8 *wa1, r_8 *wa2, r_8 *wa3);
+extern int dadf5_(integer *ido, integer *l1, r_8 *cc, r_8 *ch, r_8 *wa1, r_8 *wa2, r_8 *wa3, r_8 *wa4);
+extern int dadfg_(integer *ido, integer *ip, integer *l1, integer *idl1, r_8 *cc, r_8 *c1, r_8 *c2, r_8 *ch, r_8 *ch2, r_8 *wa);
+extern int dfftb_(integer *n, r_8 *r__, r_8 *wsave);
+extern int dfftb1_(integer *n, r_8 *c__, r_8 *ch, r_8 *wa, int_8 *ifac);
+extern int dfftf_(integer *n, r_8 *r__, r_8 *wsave);
+extern int dfftf1_(integer *n, r_8 *c__, r_8 *ch, r_8 *wa, int_8 *ifac);
+extern int dffti_(integer *n, r_8 *wsave);
+extern int dffti1_(integer *n, r_8 *wa, int_8 *ifac);
+extern int dsinqb_(integer *n, r_8 *x, r_8 *wsave);
+extern int dsinqf_(integer *n, r_8 *x, r_8 *wsave);
+extern int dsinqi_(integer *n, r_8 *wsave);
+extern int dsint_(integer *n, r_8 *x, r_8 *wsave);
+extern int dsint1_(integer *n, r_8 *war, r_8 *was, r_8 *xh, r_8 *x, int_8 *ifac);
+extern int dsinti_(integer *n, r_8 *wsave);
 
 /* Rerunning f2c -P may change prototypes or declarations. */