Index: trunk/SophyaPI/PIext/nomhistadapter.cc
===================================================================
--- trunk/SophyaPI/PIext/nomhistadapter.cc	(revision 714)
+++ trunk/SophyaPI/PIext/nomhistadapter.cc	(revision 719)
@@ -318,5 +318,4 @@
 }
 
-#ifdef SANS_EVOLPLANCK
 //-------------------------------------------------------------------------
 // Class Adaptateur d'objet (Pour NamedObjMgr) d'objet XNTuple
@@ -352,6 +351,6 @@
 mNt->Write(pos,0,tag);
 #else
-string s = typeid(*mObj).name();
-cout << "NOMAdapter_XNTuple::SavePPF() - Error : Not supported for " << s << endl;
+ObjFileIO<XNTuple> fio(mNt);
+fio.Write(pos, nom);
 #endif
 }
@@ -372,4 +371,3 @@
 }
 
-#endif  // SANS_EVOLPLANCK
-
+
Index: trunk/SophyaPI/PIext/nomhistadapter.h
===================================================================
--- trunk/SophyaPI/PIext/nomhistadapter.h	(revision 714)
+++ trunk/SophyaPI/PIext/nomhistadapter.h	(revision 719)
@@ -13,7 +13,5 @@
 #include "ntuple.h"
 
-#ifdef SANS_EVOLPLANCK
 #include "xntuple.h"
-#endif
 
 //-------------------------------------------------------------------------
@@ -118,5 +116,4 @@
 };
 
-#ifdef SANS_EVOLPLANCK
 //-------------------------------------------------------------------------
 // Class Adaptateur d'objet (Pour NamedObjMgr) d'objet XNTuple 
@@ -141,5 +138,4 @@
 };
 
-#endif  // SANS_EVOLPLANCK
 
 
Index: trunk/SophyaPI/PIext/nomtmatvecadapter.cc
===================================================================
--- trunk/SophyaPI/PIext/nomtmatvecadapter.cc	(revision 714)
+++ trunk/SophyaPI/PIext/nomtmatvecadapter.cc	(revision 719)
@@ -211,6 +211,6 @@
 #pragma define_template NOMAdapter_TMatrix<r_4>
 #pragma define_template NOMAdapter_TMatrix<r_8>
-#pragma define_template NOMAdapter_TMatrix< complex<float> >
-#pragma define_template NOMAdapter_TMatrix< complex<double> >
+#pragma define_template NOMAdapter_TMatrix< complex<r_4> >
+#pragma define_template NOMAdapter_TMatrix< complex<r_8> >
 //#pragma define_template NTupInt_TMatrix<uint_2>
 //#pragma define_template NTupInt_TMatrix<int_2>
@@ -218,6 +218,6 @@
 #pragma define_template NTupInt_TMatrix<r_4>
 #pragma define_template NTupInt_TMatrix<r_8>
-#pragma define_template NTupInt_TMatrix< complex<float> >
-#pragma define_template NTupInt_TMatrix< complex<double> >
+#pragma define_template NTupInt_TMatrix< complex<r_4> >
+#pragma define_template NTupInt_TMatrix< complex<r_8> >
 #endif
 
@@ -228,6 +228,6 @@
 template class NOMAdapter_TMatrix<r_4>;
 template class NOMAdapter_TMatrix<r_8>;
-template class NOMAdapter_TMatrix< complex<float> >;
-template class NOMAdapter_TMatrix< complex<double> >;
+template class NOMAdapter_TMatrix< complex<r_4> >;
+template class NOMAdapter_TMatrix< complex<r_8> >;
 // template class NTupInt_TMatrix<uint_2>;
 // template class NTupInt_TMatrix<int_2>;
@@ -235,5 +235,5 @@
 template class NTupInt_TMatrix<r_4>;
 template class NTupInt_TMatrix<r_8>;
-template class NTupInt_TMatrix< complex<float> >;
-template class NTupInt_TMatrix< complex<double> >;
+template class NTupInt_TMatrix< complex<r_4> >;
+template class NTupInt_TMatrix< complex<r_8> >;
 #endif
Index: trunk/SophyaPI/PIext/piinit.cc
===================================================================
--- trunk/SophyaPI/PIext/piinit.cc	(revision 714)
+++ trunk/SophyaPI/PIext/piinit.cc	(revision 719)
@@ -39,10 +39,9 @@
   serv->RegisterClass(new Histo2D, new NOMAdapter_Histo2D );
   serv->RegisterClass(new NTuple, new NOMAdapter_NTuple );
-#ifdef SANS_EVOLPLANCK
+
   serv->RegisterClass(new XNTuple, new NOMAdapter_XNTuple );
   char* varenv=NULL;
   if ( (varenv=getenv("PEIDA_TMP")) == NULL )   varenv=getenv("TMPDIR") ;
   if (varenv)  XNTuple::SetSwapPath(varenv);
-#endif
 
   serv->RegisterClass(new GeneralFitData, new NOMAdapter_GeneralFitData );
@@ -58,8 +57,8 @@
   serv->RegisterClass(new TVector<r_8>, new NOMAdapter_TMatrix<r_8> );
   serv->RegisterClass(new TMatrix<r_8>, new NOMAdapter_TMatrix<r_8> );
-  serv->RegisterClass(new TVector<complex<float> >, new NOMAdapter_TMatrix<complex<float> > );
-  serv->RegisterClass(new TMatrix<complex<float> >, new NOMAdapter_TMatrix<complex<float> > );
-  serv->RegisterClass(new TVector<complex<double> >, new NOMAdapter_TMatrix<complex<double> > );
-  serv->RegisterClass(new TMatrix<complex<double> >, new NOMAdapter_TMatrix<complex<double> > );
+  serv->RegisterClass(new TVector<complex<r_4> >, new NOMAdapter_TMatrix<complex<r_4> > );
+  serv->RegisterClass(new TMatrix<complex<r_4> >, new NOMAdapter_TMatrix<complex<r_4> > );
+  serv->RegisterClass(new TVector<complex<r_8> >, new NOMAdapter_TMatrix<complex<r_8> > );
+  serv->RegisterClass(new TMatrix<complex<r_8> >, new NOMAdapter_TMatrix<complex<r_8> > );
 #endif
 